unit u_Errorlog;

interface

uses SysUtils, Forms, Dialogs, ShellApi;


procedure wErr(Value: String);
procedure wErr2(Value: String);
procedure ViewLastLogFile;
function GetFilePath:string;
procedure FileCheck(Path: String);
procedure FileCheck2(Path: String;typ:integer);

implementation


const fcnt=3;
      FileNames : array[1..fcnt] of String = ('error1.txt','error2.txt','error3.txt');
      max_File_Size = 500 * 1024; // 307200;

var ErrPath: string;  // Pfad des aufrufenden Programmes
    ActIdx: Integer;  // aktueller Filename-Index
    ftext:string;
    fcount:integer;

procedure ViewLastLogFile;
begin
  ShellExecute(Application.Handle, 'open', PChar(FileNames[ActIdx]),
               nil, PChar(ExtractFilePath(Application.Exename)), 9);
end;

function GetFilePath:string;
begin
  GetFilePath:=ErrPath;
end;

procedure GetActErrorLog;
var i:Integer;
    j, Age:Integer;
begin
  ErrPath:=ExtractFilePath(Application.Exename);
  Age:=-2;     ActIdx:=0;
  for i:=1 to 3 do
  begin
    j:=FileAge(ErrPath + FileNames[i]);
    if j > Age then
    begin
      Age:=j;
      ActIdx:=i;
    end;
  end;
end;

procedure FileCheck2(Path: String;typ:integer);
var byteFile: File of Byte;
    txtFile: TextFile;
begin
  if FileExists(Path) then
  begin                                  // datei existiert
    if typ=3 then
      Rewrite(byteFile, Path)            // datei wird neu angelegt
    else
      AssignFile(byteFile, Path);
    Reset(byteFile);
    CloseFile(byteFile);
  end
  else                                   // datei existiert nicht
  begin
    Assign(txtFile, Path);
    Rewrite(txtFile);                    // datei anlegen
    CloseFile(txtFile);
  end;
end;

procedure FileCheck(Path: String);
var byteFile: File of Byte;
    txtFile: TextFile;
begin
  if FileExists(Path) then
  begin                                  // Error.log existiert
     AssignFile(byteFile, Path);
     Reset(byteFile);
     //Form1.edit1.text:=inttostr(FileSize(byteFile));
     if FileSize(byteFile) > max_File_Size then // zulssige Dateigre berschritten
     begin
       if ActIdx = 5 then begin
          DeleteFile(ErrPath + FileNames[1]);
          //form1.edit2.text:=ErrPath + FileNames[1];
        end
        else begin
          DeleteFile(ErrPath + FileNames[ActIdx + 1]);
          //form1.edit2.text:=ErrPath + FileNames[ActIdx + 1];
        end;
       ActIdx:=ActIdx + 1;
       if ActIdx = 6 then ActIdx:=1;
     end;
     CloseFile(byteFile);
  end
  else                                   // Error.log existiert nicht
  begin
    //form1.edit3.text:=Path;
    Assign(txtFile, Path);
    Rewrite(txtFile);                         // Error.log anlegen
    CloseFile(txtFile);
  end;
end;

procedure wErr(Value: String);
begin
  if (value=ftext) then begin  // erneut gleicher fehler
    inc (fcount);
    if fcount<3 then werr2(value);
    if fcount=3 then werr2('Meldung : '+#39+ftext+#39+' dauert an !!!');
  end
  else begin
    if fcount>2 then begin //  mehrmals trat der gleiche fehler auf
      werr2('Ende --> Meldung : '+#39+ftext+#39+' trat '+inttostr(fcount+1)+'-mal auf.');
      werr2(value);
    end
    else
      werr2(value);
    fcount:=0;
  end;

  ftext:=value;
end;

procedure wErr2(Value: String);
var txtFile:TextFile;
    LogPath:String; // Pfad der Exe-Datei und Dateiname (hier Error.log)
begin
  LogPath:=ErrPath + FileNames[ActIdx];
  try
    FileCheck(LogPath);
    AssignFile(txtFile, LogPath);
    Append(txtFile);
    Writeln(txtFile,DateTimeToStr(now) + ' ...  ' + Value);  // Fehlermeldung
//    Writeln(txtFile,Value);  // Fehlermeldung
    CloseFile(txtFile);
  except
    MessageDlg('Fehler beim Schreiben von Error.log!', mtError, [mbOK], 0);
  end;
end;


initialization

GetActErrorLog;

end.
