unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls,filectrl,ShellAPI, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    Function LogFiles( Const path: String; Const SRec: TSearchRec ): Boolean;
  public
    procedure MyExceptionHandler(Sender : TObject; E : Exception );
    procedure DelFiles(dirname: string);
  end;


type
  TLogFunct = Function( Const path: String; Const SRec: TSearchRec ): Boolean
                of Object;

var
  Form1: TForm1;
  vwzt:integer;
  b_close,b_test:integer;

implementation

uses u_Errorlog;

{$R *.DFM}

function GetFileDate(const FileName: string; out Creation, LastAccess,
  LastWrite: TDateTime): Boolean;
var
  hFile: THandle;
  ftCreationUTC, ftLastAccessUTC, ftLastWriteUTC: TFileTime;
  ftCreationLocal, ftLastAccessLocal, ftLastWriteLocal: TFileTime;
  stCreationLocal, stLastAccessLocal, stLastWriteLocal: TSystemTime;
begin
  result:=false;
  hFile := CreateFile(PChar(FileName), GENERIC_READ, 0, nil,
  OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, 0);
  if (hFile <> INVALID_HANDLE_VALUE) then begin
    try
      //Ermittlung des Dateidatums in UTC (Weltzeit)
      if GetFileTime(hFile, @ftCreationUTC, @ftLastAccessUTC, @ftLastWriteUTC) then begin
        //Umrechnung in Ortszeit
        if FileTimeToLocalFileTime(ftCreationUTC, ftCreationLocal)
        and FileTimeToLocalFileTime(ftLastAccessUTC, ftLastAccessLocal)
        and FileTimeToLocalFileTime(ftLastWriteUTC, ftLastWriteLocal) then begin
          //Umwandlung in Systemdatumformat
          if FileTimeToSystemTime(ftCreationLocal, stCreationLocal)
          and FileTimeToSystemTime(ftLastAccessLocal, stLastAccessLocal)
          and FileTimeToSystemTime(ftLastWriteLocal, stLastWriteLocal) then begin
            //Zuweisung der Rckgabewerte
            Creation := SystemTimeToDateTime(stCreationLocal);
            LastAccess := SystemTimeToDateTime(stLastAccessLocal);
            LastWrite := SystemTimeToDateTime(stLastWriteLocal);
            result:=true;
          end;
        end;
      end;
    finally
      CloseHandle(hFile);
    end;
  end;
end;


procedure ForceForegroundWindow(hwnd: THandle);
  // (W) 2001 Daniel Rolf
  // http://www.finecode.de
  // rolf@finecode.de
var
  hlp: TForm;
begin
  hlp := TForm.Create(nil);
  try
    hlp.BorderStyle := bsNone;
    hlp.SetBounds(0, 0, 1, 1);
    hlp.FormStyle := fsStayOnTop;
    hlp.Show;
    mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
    mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
    SetForegroundWindow(hwnd);
  finally
    hlp.Free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  eingabe : array [0..80] of Char;
begin
  b_close:=0;
  b_test:=0;
  Application.OnException := MyExceptionHandler;
  GetPrivateProfileString('settings','verweilzeit','2',@eingabe[0],20,pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
  vwzt:=strtoint(eingabe);
  GetPrivateProfileString('settings','test','1',@eingabe[0],20,pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
  if eingabe[0]<>'0' then
    b_test:=1;
  GetPrivateProfileString('settings','close','0',@eingabe[0],20,pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
  if eingabe[0]<>'0' then
    b_close:=1;
  werrP('Programmstart');
end;

procedure TForm1.MyExceptionHandler(Sender : TObject; E : Exception );
begin
  MessageDlg('ERROR: ' + E.Message,mtInformation,[mbOk], 0);
  werrE('ERROR: ' + E.Message);
end;

{function GetFileDateTime(const FileName: TFileName): TDateTime;
var
  FStruct: TOFSTRUCT;
  wndFile: Integer;
begin
  wndFile := OpenFile(PChar(FileName), FStruct, OF_SHARE_DENY_NONE);
  Result  := FileDateToDateTime(FileGetDate(wndFile));
  CloseHandle(wndFile);
end; }

PROCEDURE FileOperation (CONST source, dest: STRING; op, flags: INTEGER);
VAR shf: TSHFileOpStruct;
    s1, s2: STRING;
BEGIN
 FillChar (shf, SizeOf (shf), #0);
 s1:= source + #0#0;
 s2:= dest + #0#0;
 shf.Wnd:=     0;
 shf.wFunc:=  op;
 shf.pFrom:=  PCHAR (s1);
 shf.pTo:=    PCHAR (s2);
 shf.fFlags:= flags;
 SHFileOperation (shf);
END;

PROCEDURE DeleteFileWithUndo(sFileName: string);
begin
  FileOperation (sFileName, '', FO_DELETE, FOF_ALLOWUNDO + FOF_NOCONFIRMATION);
end;

Procedure FindRecursive( Const path: String; Const mask: String;b_dir:boolean;
                         LogFunction: TLogFunct );
  Var
    fullpath: String;
    wpath:string;
  Function Recurse( Var path: String; Const mask: String ): Boolean;
    Var
      SRec: TSearchRec;
      retval: Integer;
      oldlen: Integer;
    Begin
      Recurse := True;

      oldlen := Length( path );
      (* phase 1, look for normal files *)
      retval := FindFirst( path+mask, faAnyFile, SRec );

      if b_dir=true then begin
        While retval = 0 Do Begin
          If (SRec.Attr and (faDirectory)) = faDirectory Then // directory gefunden
            If not LogFunction( path, SRec ) Then Begin
              Result := False;
              Break;
            End;
          retval := FindNext( SRec );
        End;
      end
      else begin
        While retval = 0 Do Begin
          If (SRec.Attr and (faDirectory or faVolumeID)) = 0 Then // file gefunden
            If not LogFunction( path, SRec ) Then Begin
              Result := False;
              Break;
            End;
          retval := FindNext( SRec );
        End;
      end;
      FindClose(SRec);
      If not Result Then Exit;

      (* Phase II, look for subdirectories and recurse thru them *)
      retval := FindFirst( path+'*.*', faDirectory, SRec );
      While retval = 0 Do Begin
        If (SRec.Attr and faDirectory) <> 0 Then (* we have a directory *)
          If (SRec.Name <> '.') and (SRec.Name <> '..') Then Begin
            path := path + SRec.Name + '\';
            If not Recurse( path, mask ) Then Begin

              Result := False;
              Break;
            End;
            Delete( path, oldlen+1, 255 );
          End;
        retval := FindNext( SRec );
      End;
      FindClose( SRec );
    End;
  Begin
    If path = '' Then
      GetDir(0, fullpath)
    Else
      fullpath := path;
    If fullpath[Length(fullpath)] <> '\' Then
      fullpath := fullpath + '\';
    wpath:=fullpath;
    If mask = '' Then
      Recurse( fullpath, '*.*' )
    Else
      Recurse( fullpath, mask );
End;

Function TForm1.LogFiles( Const path: String; Const SRec: TSearchRec ): Boolean;
var
  erstellung, zugriff, schreibzugriff: TDateTime;
Begin
  label1.caption:=inttostr(Listbox1.Items.Count)+' : '+path;

  If (SRec.Attr and (faDirectory)) = faDirectory Then // directory gefunden
    GetFileDate(path+SRec.Name, erstellung, zugriff, schreibzugriff)
  else
    GetFileDate(path+SRec.Name, schreibzugriff, zugriff, erstellung);

  if (erstellung<now-vwzt) then begin
    if (SRec.name<>'..') and (SRec.name<>'.') then begin
      Listbox1.Items.Add(path+SRec.Name);
    end;
  end;
  application.ProcessMessages;
  Result:=True;   (* proceeed with recursion *)
end;

procedure TForm1.DelFiles(dirname: string);
var
  i1,cnt,Attributes:integer;
  s:string;
begin
  cnt:=0;
  try
    werrP('cleaning : '+dirname);
    if directoryexists(dirname) then begin
      progressbar1.Position:=0;
      screen.Cursor:=crHourGlass;
      with Listbox1 do begin
        Clear;
        FindRecursive(dirname,'*.*',false,LogFiles);  // files finden
      end;
      if listbox1.Items.Count>0 then begin
        cnt:=0;
        progressbar1.Max:=listbox1.Items.Count-1;
        if b_test=0 then begin
          for i1:=0 to listbox1.Items.Count-1 do begin
            s:=listbox1.Items[i1];
            if s<>dirname then begin
              Attributes := FileGetAttr(s) and not faReadOnly;
              FileSetAttr(s, Attributes);
              if DeleteFile(s)=true then begin
                listbox1.Items.Delete(i1);
                listbox1.Items.Insert(i1,'deleted : '+s);
                werrP('deleted : '+s);
                inc(cnt);
              end
              else
                werrE('Fehler beim Lschen von : '+s);
            end;
            progressbar1.Position:=i1;
            application.ProcessMessages;
          end;
        end;
        werrP('Es wurden '+inttostr(cnt)+' Datei(en) im Ordner '+dirname+' gelscht.')
      end;
      with Listbox1 do begin
        Clear;
        FindRecursive(dirname,'*.*',true,LogFiles);   // directorys finden
      end;
      if listbox1.Items.Count>0 then begin
        cnt:=0;
        progressbar1.Max:=listbox1.Items.Count-1;
        if b_test=0 then begin
          for i1:=0 to listbox1.Items.Count-1 do begin
            s:=listbox1.Items[i1];
            Attributes := FileGetAttr(s) and not faReadOnly;
            FileSetAttr(s, Attributes);
            if s<>dirname then begin
              if RemoveDir(s)=true then begin
                listbox1.Items.Delete(i1);
                listbox1.Items.Insert(i1,'deleted : '+s);
                werrP('deleted : '+s);
                inc(cnt);
              end
              else
                werrE('Fehler beim Lschen von : '+s);
            end;
            progressbar1.Position:=i1;
            application.ProcessMessages;
          end;
        end;
        werrP('Es wurden '+inttostr(cnt)+' Ordner im Ordner '+dirname+' gelscht.')
      end;
      screen.Cursor:=crDefault;
      label1.Caption:='fertig !!';
      if (b_close=0) and (b_test=0) then
        showmessage('Es wurden '+inttostr(cnt)+' Dateien/Ordner gelscht.');

    end
    else
      showmessage('Das Directory '+dirname+' existiert nicht !');
  except;
    screen.Cursor:=crDefault;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  hWnd: THandle;
begin
  hWnd :=GetWindow(Handle,GW_OWNER);
  ForceForegroundWindow(hWnd);
  timer2.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  close;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  timer2.enabled:=false;
  Button1Click(self);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  tdir:string;
  eingabe : array [0..80] of Char;
  cnt:integer;
begin
  try
    tdir:='';
    cnt:=1;
    while tdir<>'ende' do begin
      GetPrivateProfileString('settings',
                              pchar('directory'+inttostr(cnt)),
                              'ende',@eingabe[0],80,
                              pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
      tdir:=eingabe;
      if tdir<>'ende' then
        DelFiles(tdir);
      inc(cnt);
    end;

    WritePrivateProfileString('settings','verweilzeit',pchar(inttostr(vwzt)),
                      pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
    WritePrivateProfileString('settings','test',pchar(inttostr(b_test)),
                      pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
    WritePrivateProfileString('settings','close',pchar(inttostr(b_close)),
                      pchar(ExtractFilePath(application.ExeName)+'deltemp.ini'));
    werrP('Programmende');
    if b_close=1 then
      timer1.enabled:=true;
  except;
    screen.Cursor:=crDefault;
  end;
end;



end.
